<?php
  /*
   * Copyright (C) 2007 Nicolas Joseph
   *
   * This program is free software: you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation, either version 3 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed in the hope that it will be useful,
   * but WITHOUT ANY WARRANTY; without even the implied warranty of
   * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   * GNU General Public License for more details.
   *
   * You should have received a copy of the GNU General Public License
   * along with this program.  If not, see <http://www.gnu.org/licenses/>.
   */

  include_once ('include/config.php');
  include_once ('include/fonctions.php');
  include_once ('include/fonctions_bbcodes.php');
  include_once ('include/fonctions_lock.php');

  function conv_bbcodes__ ($chaine)
  {
    /* L'ordre d'appel des fonctions doit tre respect ! */
    return str_replace ('&nbsp;', ' ', conv_smilies (conv_bbcodes (conv_sauts_ligne (conv_ponctuation (conv_url_bbcodes ($chaine))))));
  }

  /**
   * Convertie la date au format valide pour les flux Atom.
   *
   * @param $date : la date au format des news.
   *
   * @return La date au format Atom.
   */
  function conv_date ($date)
  {
    $d = explode ('/', $date);
    return date ('Y-m-d\T00:00:00\Z', mktime ('0', '0', '0', $d[1], $d[0], substr ($d[2], 0, 4)));
  }

  $affnvlCheminBaseNvl = 'data/nouvelles';
  $affnvlBaseNvl = $affnvlCheminBaseNvl.'/dbn.txt';

  header ('Content-Type: application/xml');

  if (version_compare (PHP_VERSION, '5.1.0', '>='))
  {
    date_default_timezone_set ('Europe/Paris');
  }

  echo '<?xml version="1.0" encoding="'.PHORTAIL_CHARSET.'"?>'."\n";
  echo '<feed xml:lang="fr-FR" xmlns="http://www.w3.org/2005/Atom">'."\n";
  echo '  <title>'.$cfgSite[0].'</title>'."\n";
  echo '  <link rel="self" href="http://'.$cfgSite[3].'" />'."\n";
  echo '  <id>http://'.$cfgSite[3].'/</id>'."\n";
  echo '  <updated>2006-09-23T19:44:56Z</updated>'."\n";
  /* verrouillage */
  if ($verrou = acq_verrou_partage ($affnvlCheminBaseNvl.'/.lock'))
  {
    /* Lecture de la base de donnees */
    $fichier = file ($affnvlBaseNvl);

    /* dverrouillage */
    liberation_verrou ($verrou);

    /* Extraction des noms des fichiers "actifs" */
    $data = array ();

    for ($i = 0; $i < count ($fichier); $i++)
    {
      $pos = explode ('|', trim ($fichier[$i]));

      if (trim ($pos[1]) == 'active')
      {
        $data[] = trim ($pos[0]);
      }
    }

    $nb_data = count ($data);
    /* Affichage des donnees */
    if (!empty ($data))
    {
      for ($i = 0; $i < $nb_data; $i++)
      {
        $filename = $affnvlCheminBaseNvl."/".$data[$i];
        if (file_exists ($filename))
        {
          include ($filename);

          echo '  <entry>'."\n";
          echo '        <title>'.$ntitre.'</title>'."\n";
          echo '        <link href="http://'.$cfgSite[3].'/nouvelles.php#news_'.($i + 1).'" rel="alternate" />'."\n";
          echo '        <updated>'.conv_date ($ndate).'</updated>'."\n";
          echo '        <content type="xhtml" xml:base="http://www.atomenabled.org" xml:space="preserve"><div xmlns="http://www.w3.org/1999/xhtml">'.conv_bbcodes__ ($ntexte).'</div></content>'."\n";
          echo '        <author><name>'.conv_html ($nauteur).'</name></author>'."\n";
          echo '        <id>http://'.$cfgSite[3].'/nouvelles.php</id>'."\n";
          echo '  </entry>'."\n";
        }
      }
    }
  }
  echo '</feed>'."\n";
?>

