<?php
  /*
   * Copyright (C) 2007 Nicolas Joseph
   *
   * This program is free software: you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation, either version 3 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed in the hope that it will be useful,
   * but WITHOUT ANY WARRANTY; without even the implied warranty of
   * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   * GNU General Public License for more details.
   *
   * You should have received a copy of the GNU General Public License
   * along with this program.  If not, see <http://www.gnu.org/licenses/>.
   */
   
  /**
   * Convertie la date au format valide pour les flux RSS.
   *
   * @param $date : la date au format des news.
   *
   * @return La date au format RSS.
   */
  function conv_date ($date)
  {
    $d = explode ('/', $date);
    return date ('r', mktime ('0', '0', '0', $d[1], $d[0], substr ($d[2], 0, 4)));
  }

  $affnvlCheminBaseNvl = 'data/nouvelles';
  $affnvlBaseNvl = $affnvlCheminBaseNvl.'/dbn.txt';

  include_once ('include/config.php');
  include_once ('include/fonctions.php');
  include_once ('include/fonctions_lock.php');

  header ('Content-Type: application/xml');

  if (version_compare (PHP_VERSION, '5.1.0', '>='))
  {
    date_default_timezone_set ('Europe/Paris');
  }

  echo '<?xml version="1.0" encoding="'.PHORTAIL_CHARSET.'"?>'."\n";
  echo '<rss version="2.0">'."\n";
  echo '  <channel>'."\n";
  echo '    <title>'.$cfgSite[0].'</title>'."\n";
  echo '    <link>http://'.$cfgSite[3].'</link>'."\n";
  echo '    <description>'.$cfgSite[1].'</description>'."\n";
  echo '    <language>fr-FR</language>'."\n";

  /* verrouillage */
  if ($verrou = acq_verrou_partage ($affnvlCheminBaseNvl.'/.lock'))
  {
    /* Lecture de la base de donnees */
    $fichier = file ($affnvlBaseNvl);

    /* dverrouillage */
    liberation_verrou ($verrou);

    /* Extraction des noms des fichiers "actifs" */
    $data = array ();

    for ($i = 0; $i < count ($fichier); $i++)
    {
      $pos = explode ('|', trim ($fichier[$i]));

      if (trim ($pos[1]) == 'active')
      {
        $data[] = trim ($pos[0]);
      }
    }

    $nb_data = count ($data);
    /* Affichage des donnees */
    if (!empty ($data))
    {
      for ($i = 0; $i < $nb_data; $i++)
      {
        $filename = $affnvlCheminBaseNvl.'/'.$data[$i];
        if (file_exists ($filename))
        {
          include ($filename);

          echo '      <item>'."\n";
          echo '        <title>'.$ntitre.'</title>'."\n";
          echo '        <link>http://'.$cfgSite[3].'/nouvelles.php</link>'."\n";
          echo '        <pubDate>'.conv_date ($ndate).'</pubDate>'."\n";
          echo '        <description></description>'."\n";
          echo '        <guid isPermaLink="false">'.($i + 1).'</guid>'."\n";
          echo '      </item>'."\n";
        }
      }
    }
  }
  echo '  </channel>'."\n";
  echo '</rss>'."\n";
?>

